#! /usr/bin/env ruby
#
# A play-server in Ruby, written by J. Mallett, for the ircd-hybrid
# testnet.
#
# $Id: plaything.rb,v 1.3 2002/03/10 02:08:34 jmallett Exp $
#

require 'socket'

# Our uplink, IPv4, IPv6, or DNS name.
connect = "3ffe:1200:3028:8f19::1"
# The port they listen on.
connect_port = 6667;
# The password to send them.
connect_passwd = "password"
# unused as of yet
accept_passwd = "#${connect_passwd}"
# What my server name is.
me_name = "plaything.rb"
# My server GECOS.
GECOS = "heaven holds a sense of wonder"

# For TS.
now = Time.now.to_i()

# Our burst data, this will set up our listener client, ruby16f, and
# put them in #me_name, such as #plaything.rb.
# To send stuff to our uplink, do
# PRIVMSG ruby16f :raw :quoted COMMAND to uplink
# such as:
# PRIVMSG ruby16f :raw :ruby16f PRIVMSG #plaything.rb :ULHAGHLUHGLUHGL
burst = <<__EOB__
NICK ruby16f 1 #{now} + ruby ruby16f.#{me_name} #{me_name} :ruby plaything
:#{me_name} SJOIN #{now} \##{me_name} +tn  :ruby16f
EOB :#{me_name}
__EOB__

while 1
  irc = TCPSocket.new("#{connect}", connect_port)
  irc.write("PASS #{connect_passwd} :TS\n")
  irc.write("CAPAB :EX EOB\n")
  irc.write("SERVER #{me_name} 1 :#{GECOS}\n")
  while irc.readline
    $_.chomp!
    source = "#{$_}"
    source.gsub!(/^:([^ ]*) .*/, '\1')
    if /^:[^ ]* EOB/
      irc.write("#{burst}")
    end
    if /^PING /
      sender = "#{$_}"
      sender.sub! ("PING ") {''}
      irc.write("PONG #{sender}\n")
    end
    if /^:[^ ]* PING/
      irc.write(":#{me_name} PONG #{me_name} #{source}\n")
    end
    if /^:[^ ]* VERSION/
      irc.write(":#{me_name} 351 #{source} plaything.rb,v.ybir.naavr. #{me_name} TSmtf\n")
    end
    if /^:[^ ]* PRIVMSG ruby16f :raw/
      raw = "#{$_}"
      raw.gsub!(/^.* :raw (.*)/, '\1')
      irc.write("#{raw}")
    end
    print "#{$_}\n"
  end
  irc.close
  sleep(30)
end
